/****************************************************************************
 * tx.feature.basic
 *   A mixin "Basic" that suplies the very basic feature of Textream
 ****************************************************************************/

module tx.feature.basic;
import tx.charset;
import std.stream;

template typeOfCharset(TS:Stream)       { alias ICharset        typeOfCharset; }
template typeOfCharset(TS:OutputStream) { alias ICharsetEncoder typeOfCharset; }
template typeOfCharset(TS:InputStream)  { alias ICharsetDecoder typeOfCharset; }

template Basic( TypeOfStream )
{
public:

	this( TypeOfStream base, typeOfCharset!(TypeOfStream) cs=null, bool close_on_destructor=false )
	{
		this.base = base;
		this.cs   = (cs ? cs : new NativeCharset);
		this.cod  = close_on_destructor;
	}

	~this()
	{
		if( cod && base )
			close();
	}

	void close()
	{
		base.close();
	}

private:

	TypeOfStream                 base;
	typeOfCharset!(TypeOfStream) cs;
	bool                         cod;
}
