/****************************************************************************
 * tx.feature.write_basic
 *   A mixin "Write_Basic" that suplies the very basic feature of TextWriters
 ****************************************************************************/
module tx.feature.write_basic;
public
{
	import tx.charset;
	import std.string;
	import std.cstream;
	import std.utf;
	import std.stdarg : va_list;
	import std.contracts;
}

template Write_Basic(alias base)
{
public:

	void flush()
	{
		base.flush();
	}

	void writeString(string s)
	{
		string p = cs.fromUTF8(s);
		base.writeExact(p.ptr, p.length);
	}

	void writeLine(string s)
	{
		writeString(s);
		if( cast(CFile)base ) // ugliest hack
			writeString("\n");
		else
			writeString(std.string.newline);
		flush();
	}

	void writef(...)
	{
		writefx( _arguments, _argptr );
	}

	void writefln(...)
	{
		writefxln( _arguments, _argptr );
	}

	void writefx(TypeInfo[] arguments, va_list argptr)
	{
		char[] s;
	    std.format.doFormat( delegate void (dchar c){encode(s,c);}, arguments, argptr);
		writeString(s.assumeUnique());
	}

	void writefxln(TypeInfo[] arguments, va_list argptr)
	{
		char[] s;
	    std.format.doFormat( delegate void (dchar c){encode(s,c);}, arguments, argptr);
		writeLine(s.assumeUnique());
	}
}
